#ifndef _GLIDER_H_
#define _GLIDER_H_

#include "vector3d.h"

//Glider Game Object.

class GLIDER
{
 public:
  GLIDER();
  void TurnLeft(bool yes);
  void TurnRight(bool yes);
  void TiltUp(bool yes);
  void TiltDown(bool yes);
  void ThrusterOn(bool yes);
  void UseBoost(void);
  void UpdateDirection(void);
  void GetCameraPosition(VECTOR3D &camera);
  void GetNextPosition(VECTOR3D &next_pos);
  void SetPosition(VECTOR3D &pos);
  void GetPosition(VECTOR3D &pos);
  void SetVelocity(VECTOR3D &vel);
  float GetSpeed(void);
  void ResetVelocity(void);
  void ResetYVelocity(void);
  void SetDirection(VECTOR3D &dir);
  void Draw(void);
 private:
  VECTOR3D position, velocity, direction;
  bool turning;
  float engine_intensity;
};

#endif
