#ifndef _HEIGHTMAP_H_
#define _HEIGHTMAP_H_

#include <allegro.h>

class HEIGHTMAP
{
 public:
  HEIGHTMAP();
  ~HEIGHTMAP();
  void LoadBitmap(const char *filename);
  void Destroy(void);
  void SetCenterXYZ(float x, float y, float z);
  void SetPixelSize(float pix_size);
  void SetMinMaxHeight(float minimum_y, float maximum_y);
  void GenerateHeightmapVertexData(void);
  void Draw(void);
  float CollisionHeight(float x_pos, float z_pos);
 private:
  void SendGLCommands(void);
  BITMAP *heightmap_data;
  float *heightmap_vertex;
  unsigned int heightmap_vertex_num;
  float x_pos, y_pos, z_pos, min_y, max_y, pixel_size;
  unsigned int display_list;
};

#endif
