#ifndef LEVEL_SELECT_LOOP_H_
#define LEVEL_SELECT_LOOP_H_

#include <OpenLayer.hpp>
#include <vector>
#include "game_loop.h"

struct LEVEL_DATA
{
  char name[60];
  char filename[60];
};

struct TIME_DATA
{
  int min, sec, ms;
};

class LEVEL_SELECT_LOOP : public GAME_LOOP
{
 public:
  virtual void Init(void);
  virtual bool Logic(void);
  virtual void Shutdown(void);
  
  void LoadLevels(void);
  bool CancelLevelLoad(void);
  char *GetFilenameToLoad(void);
  int GetTTB(void);
 private:
  int num_levels;
  int cur_level;
  float bg_rotation;
  bool go_back;
  float select_rotation;
  ol::TextRenderer title_font;
  ol::TextRenderer selection_font;
  std::vector<LEVEL_DATA> levels;
  std::vector<TIME_DATA> times;
  int current_selection;
  char filename_to_load[60];
  int ms_to_beat;
};

#endif
