#ifndef _MAIN_GAME_LOOP_H_
#define _MAIN_GAME_LOOP_H_

#include <OpenLayer.hpp>
#include "game_loop.h"
#include "heightmap.h"
#include "texture3d.h"
#include "glider.h"
#include "ring_list.h"
#include "music.h"

class MAIN_GAME_LOOP : public GAME_LOOP
{
 public:
  virtual void Init(void);
  virtual bool Logic(void);
  virtual void Shutdown(void);
  
  void CheckInput(void);
  void DoLogic(void);
  void DrawScene(void);
  void DrawGUI(void);
  void SetLevelFilename(char *filename);
  void ConvertTimer(int &ms, int &sec, int &min);
  int GetFinalTime(void);
  void SetTTB(int ttb);
  bool LevelComplete(void);
 private:
  bool user_quit;
  float boost;
  float timer;
  int time_tb;
  bool boosting;
  char *level_filename;
  float fade_out_alpha;
  int total_laps;
  bool level_complete;
  bool toggle_help;
  HEIGHTMAP hmap;
  TEXTURE3D tex3d;
  GLIDER player_glider;
  RING_LIST ring_list;
  MUSIC bgm;
  ol::TextRenderer main_font; //Note: Make this after everything is init.
  ol::TextRenderer big_font;
  ol::Bitmap boost_meter_texture;
  ol::Bitmap boost_inside_texture;
};

#endif
