#include "resources.h"

TEXTURE sky_texture;
TEXTURE glider_texture;
TEXTURE metal_texture;
TEXTURE sparkle_texture;
TEXTURE light_texture;
TEXTURE select_texture;

MESH sky_mesh;
MESH glider_mesh;
MESH select_mesh;

SOUND click_sound;
SOUND select_sound;
SOUND engines_sound;
SOUND boost_sound;
SOUND loop_sound;

MUSIC clear_music;
MUSIC lose_music;

void LoadResources(void)
{
  sky_texture.Load("data/sky.png");
  glider_texture.Load("data/glider.png");
  metal_texture.Load("data/metal.png");
  sparkle_texture.Load("data/sparkle.png");
  light_texture.Load("data/light.png");
  select_texture.Load("data/select.png");
  
  sky_mesh.Load("data/sky.msh");
  sky_mesh.SetTexture(&sky_texture);
  glider_mesh.Load("data/glider.msh");
  glider_mesh.SetTexture(&glider_texture);
  select_mesh.Load("data/select.msh");
  select_mesh.SetTexture(&select_texture);
  
  click_sound.Load("data/click.wav");
  select_sound.Load("data/select.wav");
  engines_sound.Load("data/engines.wav");
  boost_sound.Load("data/boost.wav");
  loop_sound.Load("data/loop.wav");
  
  clear_music.LoadMidi("data/clear.mid");
  lose_music.LoadMidi("data/lose.mid");
}

void DestroyResources(void)
{
  sky_texture.Destroy();
  sky_mesh.Destroy();
  glider_texture.Destroy();
  glider_mesh.Destroy();
  metal_texture.Destroy();
  sparkle_texture.Destroy();
  light_texture.Destroy();
  select_mesh.Destroy();
  select_texture.Destroy();
  click_sound.Destroy();
  select_sound.Destroy();
  engines_sound.Destroy();
  boost_sound.Destroy();
  loop_sound.Destroy();
  clear_music.Destroy();
  lose_music.Destroy();
}
