#include "ring_list.h"
#include "resources.h"

void RING_LIST::AddRing(RING &new_ring)
{
  if(rings.size() == 0)
  {
    current_target_ring = 0;
    new_ring.SetTarget(true);
  }
  else
  {
    new_ring.SetTarget(false);
  }
  
  rings.push_back(new_ring);
}

void RING_LIST::CheckCollisionWithTarget(VECTOR3D &ship_pos)
{
  if(current_target_ring < rings.size())
  {
    if(rings[current_target_ring].CheckPointCollision(ship_pos))
    {
      loop_sound.Play();
      rings[current_target_ring].SetTarget(false);
      current_target_ring++;
      if(!GotThenAll())
        rings[current_target_ring].SetTarget(true);
      else
      {
        laps_left--;
        if(laps_left > 0)
        {
          current_target_ring = 0;
          rings[0].SetTarget(true);
        }
      }
    }
  }
}

bool RING_LIST::GotThenAll(void)
{
  if(current_target_ring >= rings.size())
  {
    return true;
  }
  return false;
}

void RING_LIST::DrawRings(void)
{
  for(unsigned int i = 0; i < rings.size(); i++)
  {
    if(i != current_target_ring)
    {
      rings[i].Draw();
    }
  }
  if(!GotThenAll())
    rings[current_target_ring].Draw();
}

void RING_LIST::Destroy(void)
{
  rings.clear();
  current_target_ring = 0;
}

void RING_LIST::SetLaps(int laps)
{
  laps_left = laps;
}

int RING_LIST::GetLapsLeft(void)
{
  return laps_left;
}
