#include "sound.h"

SOUND::SOUND()
{
  sample = NULL;
}

SOUND::~SOUND()
{
  Destroy();
}

void SOUND::Load(const char *filename)
{
  if(sample != NULL)
    Destroy();
    
  sample = load_wav(filename);
}

void SOUND::Play(void)
{
  if(sample != NULL)
    play_sample(sample, 255, 128, 1000, 0);
}

void SOUND::PlayRepeat(void)
{
  if(sample != NULL)
    play_sample(sample, 255, 128, 1000, 1);
}

void SOUND::Stop(void)
{
  if(sample != NULL)
    stop_sample(sample);
}

void SOUND::Destroy(void)
{
  if(sample != NULL)
  {
    destroy_sample(sample);
    sample = NULL;
  }
}
