#include "stage_clear_loop.h"
#include "graphics.h"
#include "resources.h"
#include "input.h"
#include <GL/glut.h>

void STAGE_CLEAR_LOOP::Init(void)
{
  bg_rotation = 0.0f;
  big_text.Load("data/font.ttf", 60, 60, ol::Rgba::WHITE, 0);
  small_text.Load("data/font.ttf", 32, 32, ol::Rgba::WHITE, 0);
}

bool STAGE_CLEAR_LOOP::Logic(void)
{
  char ttb_text[100];
  
  Init3DDrawingMode();
  
  glPushMatrix();
  
  glDisable(GL_TEXTURE_2D);
  glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
  
  glTranslatef(-20.0f, 0.0f, -20.0f);
  glRotatef(bg_rotation, 0.0f, 1.0f, 0.0f);
  glRotatef(90.0, 1.0f, 0.0f, 0.0f);
  
  glutWireSphere(30.0f, 40, 40);
  
  bg_rotation += 30.0f * frame_time;
  
  glPopMatrix();  
  
  Init2DDrawingMode();
  
  big_text.Print("Stage Clear!", 400 - big_text.FirstLineWidth("Stage Clear!") / 2, 100);
  
  sprintf(ttb_text, "Time to Beat: %i:%i:%i", ttb_min, ttb_sec, ttb_ms);
  small_text.Print(ttb_text, 400 - small_text.FirstLineWidth(ttb_text) / 2, 180);
  
  sprintf(ttb_text, "Your Time: %i:%i:%i", at_min, at_sec, at_ms);
  small_text.Print(ttb_text, 400 - small_text.FirstLineWidth(ttb_text) / 2, 210);
  
  if(actual_time_in_ms <= ttb_in_ms)
  {
    big_text.Print("You Win!", 400 - big_text.FirstLineWidth("You Win") / 2, 310);
  }
  else
  {
    big_text.Print("Try Again!", 400 - big_text.FirstLineWidth("Try Again") / 2, 310);
  }
  
  if(KeyPress(KEY_ESC) || KeyPress(KEY_ENTER) || KeyPress(KEY_LCONTROL))
  {
    return false;
  }
  return true;
}

void STAGE_CLEAR_LOOP::Shutdown(void)
{
  big_text.Destroy();
  small_text.Destroy();
}

void STAGE_CLEAR_LOOP::SetTTB(int ttb)
{
  ttb_in_ms = ttb;
  
  ttb_ms = ttb % 1000;
  ttb = ttb / 1000;
  ttb_sec = ttb % 60;
  ttb_min = ttb / 60;
}

void STAGE_CLEAR_LOOP::SetActualTime(int ac_time)
{
  actual_time_in_ms = ac_time;
  
  at_ms = ac_time % 1000;
  ac_time /= 1000;
  at_sec = ac_time % 60;
  at_min = ac_time / 60;
}
