#include "tins_loop.h"
#include "graphics.h"
#include "input.h"
#include "resources.h"

void TINS_LOOP::Init(void)
{
  std::ifstream ascii("data/tins.txt");
  
  text = new char[2056];
  ascii.get(text, 2056, '\0');
  font.Load("data/zig.ttf", 24, 24, ol::Rgba::GREEN, 0);
  screen_alpha = 1.0f;
  fading_in = true;
}

bool TINS_LOOP::Logic(void)
{
  Init2DDrawingMode();
  font.Print(text, 40, 200);
  
  font.Print("NyanKoneko Presents...  Tins '06!", 90, 350);
  
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glDisable(GL_TEXTURE_2D);
  
  glBegin(GL_QUADS);
  
  glColor4f(0.0f, 0.0f, 0.0f, screen_alpha);
  glVertex3f(-400.0f, 300.0f, 0.0f);
  glVertex3f(-400.0f, -300.0f, 0.0f);
  glVertex3f(400.0f, -300.0f, 0.0f);
  glVertex3f(400.0f, 300.0f, 0.0f);
  
  glEnd();
  
  
  if(fading_in)
  {
    screen_alpha -= 0.4f * frame_time;
    if(screen_alpha <= 0.0f)
    {
      fading_in = false;
      screen_alpha = 0.0f;
    }
  }
  else
  {
    screen_alpha += 0.4f * frame_time;
    if(screen_alpha >= 1.0f)
    {
      return false;
    }
  }
  
  if(KeyPress(KEY_ESC) || KeyPress(KEY_ENTER))
  {
    select_sound.Play();
    return false;
  }
  return true;
}

void TINS_LOOP::Shutdown(void)
{
  font.Destroy();
  delete[] text;
}
  
void TINS_LOOP::DrawAscii(void)
{
}
